'use strict';

var util = require('../../util'),
    Token = require('../token');

class ErrorToken extends Token {
  constructor(content, line, message) {
    super(content, line, message);

    this.message = message;
  }
  
  clone() {
    var content = this.getContent(),
        line = this.getLine(),
        message = this.getMessage(),
        errorToken = new ErrorToken(content, line, message);
    
    return errorToken;
  }
  
  getMessage() {
    return this.message;
  }

  getHTML() {
    var content = this.getContent(),
        innerHTML = content, ///
        className = 'error',  ///
        message = this.message,
        sanitisedInnerHTML = util.sanitise(innerHTML),
        html = `<span class="${className}" data-message="${message}">${sanitisedInnerHTML}</span>`;

    return html;
  }
}

module.exports = ErrorToken;
